import os,sys, platform

# Adjust the fortran compiler ID, if required, on 64bit platforms
def get_compiler64(fcompiler):
  fcomp = os.path.basename(fcompiler)
  
  # In the case of ifort, need to distinguish between
  # 32 and 64bit platform
  if fcomp == 'ifort':
    myarch = platform.machine()
    if myarch == 'x86_64':
      fcomp = 'ifort64'
    return fcomp
  else:
    return fcompiler

def detect_fortran_compiler(full_path=True):


  fortrans = """
ifort
efc
ifc
g77
gfortran
f90
f95
g95
xlf90
fort77
pgf77
pgf90
cf77
xlf
ghf77
"""
  if os.environ.has_key('FC'):
    return get_compiler64(os.environ['FC'])

  for f in fortrans.split():
    i,o=os.popen4('which '+f)
    ln=o.readlines()
    o.close()
    i.close()
    if not 'no' in ln[0].lower().split():
      if full_path :
        return get_compiler64(ln[0].strip())
      else:
        return get_compiler64(f)

if __name__=="__main__":
  print detect_fortran_compiler()
